Index: src/include/device/pci_ids.h
===================================================================
--- src/include/device/pci_ids.h	(Revision 4427)
+++ src/include/device/pci_ids.h	(Arbeitskopie)
@@ -1203,6 +1203,21 @@
 #define PCI_DEVICE_ID_VIA_CN700_VLINK	0x7314
 #define PCI_DEVICE_ID_VIA_CN700_BRIDGE	0xB198
 #define PCI_DEVICE_ID_VIA_CN700_VGA	0x3344
+#define PCI_DEVICE_ID_VIA_VX800_NB_HOST_BUS 0x2409
+#define PCI_DEVICE_ID_VIA_VX800_NB_HOST_CTRL	0x0409
+#define PCI_DEVICE_ID_VIA_VX800_NB_CTC	0x5409
+//#define PCI_DEVICE_ID_VIA_VX800_LPC	0x8409
+#define PCI_DEVICE_ID_VIA_VX800_LPC	0x8353
+#define PCI_DEVICE_ID_VIA_VX800_VGA	0x5122
+//#define PCI_DEVICE_ID_VIA_VX800_IDE	0xC409
+#define PCI_DEVICE_ID_VIA_VX800_IDE	0x5324
+#define PCI_DEVICE_ID_VIA_VX800_MEMCTRL	0x3409
+#define PCI_DEVICE_ID_VIA_VX800_NB_VLINK	0x7409
+#define PCI_DEVICE_ID_VIA_VX800_SB_VLINK	0xa353
+#define PCI_DEVICE_ID_VIA_VX800_NB_PMU	0x4409
+#define PCI_DEVICE_ID_VIA_VX800_SB_P2P	0xB353
+#define PCI_DEVICE_ID_VIA_VX800_UHCI 	0x3038
+#define PCI_DEVICE_ID_VIA_VX800_EHCI 	0x3104
 #define PCI_DEVICE_ID_VIA_CN400_AGP	0x0259
 #define PCI_DEVICE_ID_VIA_CN400_ERR	0x1259
 #define PCI_DEVICE_ID_VIA_CN400_HOST	0x2259
Index: src/cpu/via/car/disable_cache_as_ram.c
===================================================================
--- src/cpu/via/car/disable_cache_as_ram.c	(Revision 0)
+++ src/cpu/via/car/disable_cache_as_ram.c	(Revision 0)
@@ -0,0 +1,101 @@
+/* by yhlu 6.2005 */
+/* be warned, this file will be used other cores and core 0 / node 0 */
+static inline __attribute__((always_inline)) void disable_cache_as_ram(void)
+{
+
+           __asm__ volatile (
+	/* 
+	FIXME : backup stack in CACHE_AS_RAM into mmx and sse and after we get STACK up, we restore that.
+		It is only needed if we want to go back
+	*/
+	
+        /* We don't need cache as ram for now on */
+        /* disable cache */
+        "movl    %cr0, %eax\n\t"
+        "orl    $(0x1<<30),%eax\n\t"
+        "movl    %eax, %cr0\n\t"
+
+
+        /* Set the default memory type and disable fixed and enable variable MTRRs */
+        "movl    $0x2ff, %ecx\n\t"
+	//"movl    $MTRRdefType_MSR, %ecx\n\t"
+        "xorl    %edx, %edx\n\t"
+        /* Enable Variable and Disable Fixed MTRRs */
+        "movl    $0x00000800, %eax\n\t"
+        "wrmsr\n\t"
+
+        /* enable caching for first 1M using variable mtrr */
+        "movl    $0x200, %ecx\n\t"
+        "xorl    %edx, %edx\n\t"
+        "movl     $(0 | 6), %eax\n\t"
+	//"movl     $(0 | MTRR_TYPE_WRBACK), %eax\n\t"
+        "wrmsr\n\t"
+ 
+/* enable cache  0-7ffff, 80000-9ffff, c0000-fffff;
+if cache 0-1M, then when resume from s3, there is stange color on screen for 2 sec. 
+suppose problem of a0000-bfffff.*/
+        "movl    $0x201, %ecx\n\t"
+        "movl    $0x0000000f, %edx\n\t" /* AMD 40 bit 0xff*/
+ 	 "movl    $((~(( 0 + 0x80000) - 1)) | 0x800), %eax\n\t"
+        "wrmsr\n\t"
+        
+        "movl    $0x202, %ecx\n\t"
+        "xorl    %edx, %edx\n\t"
+        "movl     $(0x80000 | 6), %eax\n\t"
+        "orl     $(0 | 6), %eax\n\t"
+        "wrmsr\n\t"
+
+        "movl    $0x203, %ecx\n\t"
+        "movl    $0x0000000f, %edx\n\t" /* AMD 40 bit 0xff*/
+ 	 "movl    $((~(( 0 + 0x20000) - 1)) | 0x800), %eax\n\t"
+        "wrmsr\n\t"
+        
+        "movl    $0x204, %ecx\n\t"
+        "xorl    %edx, %edx\n\t"
+        "movl     $(0xc0000 | 6), %eax\n\t"
+        "orl     $(0 | 6), %eax\n\t"
+        "wrmsr\n\t"
+
+        "movl    $0x205, %ecx\n\t"
+        "movl    $0x0000000f, %edx\n\t" /* AMD 40 bit 0xff*/
+ 	 "movl    $((~(( 0 + 0x40000) - 1)) | 0x800), %eax\n\t"
+        "wrmsr\n\t"        
+        
+	/*cache CONFIG_XIP_ROM_BASE-SIZE to speedup the coreboot code*/
+	 "movl    $0x206, %ecx\n\t"
+        "xorl    %edx, %edx\n\t"
+	"movl   $(0xffffffff - CONFIG_ROM_SIZE+ 1),%eax\n\t"
+        "orl     $(0 | 6), %eax\n\t"
+        "wrmsr\n\t"
+
+	 "movl    $0x207, %ecx\n\t"
+        "xorl    %edx, %edx\n\t"
+	"movl     $CONFIG_ROM_SIZE,%eax\n\t"
+        "decl	%eax\n\t"
+        "notl	%eax\n\t"
+        "orl     $(0 | 0x800), %eax\n\t"
+        "wrmsr\n\t"
+
+        /* enable cache */
+        "movl    %cr0, %eax\n\t"
+        "andl    $0x9fffffff,%eax\n\t"
+        "movl    %eax, %cr0\n\t"
+	 "invd\n\t"
+        );
+}
+
+static void disable_cache_as_ram_bsp(void)
+{
+	__asm__ volatile (
+//		"pushl %eax\n\t"
+ 		"pushl %edx\n\t"
+ 		"pushl %ecx\n\t"
+	);
+
+	disable_cache_as_ram();
+        __asm__ volatile (
+                "popl %ecx\n\t"
+                "popl %edx\n\t"
+//                "popl %eax\n\t"
+        );
+}
Index: src/cpu/via/car/post_cache_as_ram.c
===================================================================
--- src/cpu/via/car/post_cache_as_ram.c	(Revision 0)
+++ src/cpu/via/car/post_cache_as_ram.c	(Revision 0)
@@ -0,0 +1,99 @@
+/* 2005.6 by yhlu 
+ * 2006.3 yhlu add copy data from CAR to ram
+ */
+#include "cpu/via/car/disable_cache_as_ram.c"
+
+#include "cpu/amd/car/clear_init_ram.c"
+
+static inline void print_debug_pcar(const char *strval, uint32_t val)
+{
+#if CONFIG_USE_PRINTK_IN_CAR
+        printk_debug("%s%08x\r\n", strval, val);
+#else
+        print_debug(strval); print_debug_hex32(val); print_debug("\r\n");
+#endif
+}
+
+static void inline __attribute__((always_inline))  memcopy(void *dest, const void *src, unsigned long bytes)
+{
+        __asm__ volatile(
+                "cld\n\t"
+                "rep; movsl\n\t"
+                : /* No outputs */
+                : "S" (src), "D" (dest), "c" ((bytes)>>2)
+                );
+}
+/* Disable Erratum 343 Workaround, see RevGuide for Fam10h, Pub#41322 Rev 3.33 */
+
+static void post_cache_as_ram(void)
+{
+
+#if 1
+        {
+        /* Check value of esp to verify if we have enough rom for stack in Cache as RAM */
+        unsigned v_esp;
+        __asm__ volatile (
+                "movl   %%esp, %0\n\t"
+                : "=a" (v_esp)
+        );
+        print_debug_pcar("v_esp=", v_esp);
+        }
+#endif
+
+	unsigned testx = 0x5a5a5a5a;
+	print_debug_pcar("testx = ", testx);
+
+	/* copy data from cache as ram to 
+		ram need to set CONFIG_LB_MEM_TOPK to 2048 and use var mtrr instead.
+	 */
+#if CONFIG_LB_MEM_TOPK <= 1024
+        #error "You need to set CONFIG_LB_MEM_TOPK greater than 1024"
+#endif
+	
+        __asm__ volatile (
+                /* set new esp */ /* before CONFIG_RAMBASE */
+                "subl   %0, %%ebp\n\t"
+                "subl   %0, %%esp\n\t"
+                ::"a"( (CONFIG_DCACHE_RAM_BASE + CONFIG_DCACHE_RAM_SIZE)- (CONFIG_LB_MEM_TOPK<<10) )
+        ); // We need to push %eax to the stack (CAR) before copy stack and pop it later after copy stack and change esp
+#if 0
+        __asm__ volatile (
+	        "popl   %eax\n\t"
+        );
+#endif
+
+
+	/* We can put data to stack again */
+
+        /* only global variable sysinfo in cache need to be offset */
+        print_debug("Done\r\n");
+        print_debug_pcar("testx = ", testx);
+
+	print_debug("Disabling cache as ram now \r\n");
+	disable_cache_as_ram_bsp();  
+
+        print_debug("Clearing initial memory region: ");
+        clear_init_ram(); //except the range from [(CONFIG_LB_MEM_TOPK<<10) - CONFIG_DCACHE_RAM_SIZE, (CONFIG_LB_MEM_TOPK<<10))
+        print_debug("Done\r\n");
+
+//	dump_mem((CONFIG_LB_MEM_TOPK<<10) - 0x8000, (CONFIG_LB_MEM_TOPK<<10) - 0x7c00);
+
+#ifndef CONFIG_MEM_TRAIN_SEQ
+#define CONFIG_MEM_TRAIN_SEQ 0
+#endif
+//        set_sysinfo_in_ram(1); // So other core0 could start to train mem
+
+#if CONFIG_MEM_TRAIN_SEQ == 1
+//	struct sys_info *sysinfox = ((CONFIG_LB_MEM_TOPK<<10) - CONFIG_DCACHE_RAM_GLOBAL_VAR_SIZE);
+
+        // wait for ap memory to trained
+//        wait_all_core0_mem_trained(sysinfox); // moved to lapic_init_cpus.c
+#endif
+        /*copy and execute coreboot_ram */
+        copy_and_run();
+        /* We will not return */
+
+        print_debug("should not be here -\r\n");
+
+}
+
Index: src/cpu/via/car/cache_as_ram.inc
===================================================================
--- src/cpu/via/car/cache_as_ram.inc	(Revision 4427)
+++ src/cpu/via/car/cache_as_ram.inc	(Arbeitskopie)
@@ -8,8 +8,6 @@
  * Copyright (C) 2007 coresystems GmbH
  * (Written by Stefan Reinauer <stepan@coresystems.de> for coresystems GmbH)
  * Copyright (C) 2007,2008 Carl-Daniel Hailfinger
- * Copyright (C) 2008 VIA Technologies, Inc.
- * (Written by Jason Zhao <jasonzhao@viatech.com.cn> for VIA)
  * 
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -29,7 +27,7 @@
 #define	CacheBase CONFIG_DCACHE_RAM_BASE
 
 
-#include	<cpu/x86/mtrr.h>
+#include <cpu/x86/mtrr.h>
 
 	/* Save the BIST result */
 	movl    %eax, %ebp
@@ -102,19 +100,22 @@
 	andl    $0x9fffffff,%eax
 	movl    %eax, %cr0
 
+	cld
+
 	/* Read the range with lodsl*/
-	cld
+	movl    XIP_ROM_BASE, %esi
+	movl    $(XIP_ROM_SIZE>>2), %ecx
+	rep     lodsl	
+
 	movl    $CacheBase, %esi
-	movl    %esi, %edi
 	movl    $(CacheSize>>2), %ecx
 	rep     lodsl
 
-	movl    $CacheBase, %esi
-	movl    %esi, %edi
+	movl    $CacheBase, %edi
 	movl    $(CacheSize>>2), %ecx
 
 	/* 0x5c5c5c5c is a memory test pattern.
-         * TODO: Check if everything works with the zero pattern as well. */
+     * TODO: Check if everything works with the zero pattern as well. */
 	/*xorl    %eax, %eax*/
 	xorl    $0x5c5c5c5c,%eax
 	rep     stosl
@@ -125,8 +126,8 @@
 	rep     lodsl
 
 	/* The key point of this CAR code is C7 cache does not turn into
-	 * "no fill" mode, which is not compatible with general CAR code.
-	 */
+    * "no fill" mode, which is not compatible with general CAR code.
+    */
 
 	movl    $(CacheBase+CacheSize-4), %eax
 	movl    %eax, %esp
@@ -152,11 +153,11 @@
 #endif
 
 	/* Restore the BIST result */
-	movl	%ebp, %eax
+	movl %ebp, %eax
 	/* We need to set ebp ? No need */
-	movl	%esp, %ebp
-	pushl 	%eax  /* bist */
-	call    amd64_main
+	movl %esp, %ebp
+	pushl %eax  /* bist */
+	call amd64_main
 	/* We will not go back */
 
 fixed_mtrr_msr:
Index: src/cpu/via/model_c7/model_c7_init.c
===================================================================
--- src/cpu/via/model_c7/model_c7_init.c	(Revision 4427)
+++ src/cpu/via/model_c7/model_c7_init.c	(Arbeitskopie)
@@ -60,6 +60,7 @@
 	0x0406, 0x0806,		// 400MHz, 796mV --> 800MHz, 796mV      C7-M ULV
 	0x0406, 0x0a06,		// 400MHz, 796mV --> 1000MHz, 796mV
 	0x0406, 0x0c09,		// 400MHz, 796mV --> 1200MHz, 844mV
+	0x0406, 0x0609,		// 
 	0x0806, 0x0c09,		// 800MHz, 796mV --> 1200MHz, 844mV
 	0x0406, 0x0f10,		// 400MHz, 796mV --> 1500MHz, 956mV
 	0x0806, 0x1010,		// 800MHz, 796mV --> 1600MHz, 956mV
@@ -100,6 +101,13 @@
 		}
 	}
 
+#if 1 
+	/* Some value may not be included in c7d_speed_translation,
+	so a more general way is needed:*/
+	current=msr.hi&0xffff;
+	msr.lo=msr.lo&0xffff0000;
+	msr.lo=msr.lo|current;
+#else
 	current = msr.lo & 0xffff;
 
 	// Start out with no change.
@@ -129,6 +137,7 @@
 
 	msr.lo = new;
 	msr.hi = 0;
+#endif
 	printk_debug(" new msr.lo = %x\n", msr.lo);
 
 	wrmsr(MSR_IA32_PERF_CTL, msr);
@@ -149,6 +158,12 @@
 	printk_info("Current CPU multiplier: %dx\n", (int)((msr.lo >> 8) & 0xff));
 }
 
+#if HAVE_ACPI_RESUME == 1
+char *lowmem_backup;
+char *lowmem_backup_ptr;
+int  lowmem_backup_size;
+#endif
+
 static void model_c7_init(device_t dev)
 {
 	u8 brand;
@@ -209,6 +224,11 @@
 
 	/* Enable the local cpu apics */
 	setup_lapic();
+
+	#if HAVE_ACPI_RESUME == 1
+	/*lowmem_backup_size is need by acpi_jump_to_wakeup() in acpi.c, since c7 has no dual core,so set size to 0*/
+	lowmem_backup_size=0;
+	#endif
 };
 
 static struct device_operations cpu_dev_ops = {
@@ -224,6 +244,7 @@
 	{X86_VENDOR_CENTAUR, 0x06A0},	// VIA C7 Esther
 	{X86_VENDOR_CENTAUR, 0x06A9},	// VIA C7 Esther
 	{X86_VENDOR_CENTAUR, 0x06D0},	// VIA C7-M
+	{X86_VENDOR_CENTAUR, 0x06F0},	//
 	{0, 0},
 };
 
Index: src/cpu/x86/tsc/Config.lb
===================================================================
--- src/cpu/x86/tsc/Config.lb	(Revision 4427)
+++ src/cpu/x86/tsc/Config.lb	(Arbeitskopie)
@@ -2,7 +2,7 @@
 uses CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2
 uses CONFIG_HAVE_INIT_TIMER
 
-default CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2=0
+#default CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2=0
 if CONFIG_UDELAY_TSC 
 	default CONFIG_HAVE_INIT_TIMER=1
 	object delay_tsc.o  
Index: src/mainboard/via/vx800example/Config.lb
===================================================================
--- src/mainboard/via/vx800example/Config.lb	(Revision 0)
+++ src/mainboard/via/vx800example/Config.lb	(Revision 0)
@@ -0,0 +1,132 @@
+##
+## This file is part of the coreboot project.
+##
+## Copyright (C) 2009 One Laptop per Child, Association, Inc.
+## 
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; version 2 of the License.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+##
+
+## XIP_ROM_SIZE must be a power of 2.
+default XIP_ROM_SIZE = 64 * 1024
+include /config/nofailovercalculation.lb
+
+arch i386 end
+driver mainboard.o
+if HAVE_PIRQ_TABLE object irq_tables.o end
+if HAVE_MP_TABLE object mptable.o end
+if HAVE_ACPI_TABLES
+	object fadt.o
+	object dsdt.o
+	#object ssdt.o
+	object acpi_tables.o
+end
+# these lines maybe noused
+makerule ./failover.E
+	depends "$(MAINBOARD)/../../../arch/i386/lib/failover.c ./romcc"
+	action "./romcc -E -O --label-prefix=failover -I$(TOP)/src -I. $(CPPFLAGS) $(MAINBOARD)/../../../arch/i386/lib/failover.c -o $@"
+end
+makerule ./failover.inc
+	depends "$(MAINBOARD)/../../../arch/i386/lib/failover.c ./romcc"
+	action "./romcc    -O --label-prefix=failover -I$(TOP)/src -I. $(CPPFLAGS) $(MAINBOARD)/../../../arch/i386/lib/failover.c -o $@"
+end
+if USE_DCACHE_RAM
+  if CONFIG_USE_INIT
+    makerule ./cache_as_ram_auto.o
+      depends "$(MAINBOARD)/cache_as_ram_auto.c option_table.h"
+      action "$(CC) $(DISTRO_CFLAGS) -I$(TOP)/src -I. $(CPPFLAGS) $(MAINBOARD)/cache_as_ram_auto.c -Os -nostdinc -nostdlib -fno-builtin -Wall -c -o $@"
+    end
+  else
+    makerule ./cache_as_ram_auto.inc
+      depends "$(MAINBOARD)/cache_as_ram_auto.c option_table.h"
+      action "$(CC) $(DISTRO_CFLAGS) -I$(TOP)/src -I. $(CPPFLAGS) $(MAINBOARD)/cache_as_ram_auto.c -Os -nostdinc -nostdlib -fno-builtin -Wall -c -S -o $@"
+      action "perl -e 's/.rodata/.rom.data/g' -pi $@"
+      action "perl -e 's/.text/.section .rom.text/g' -pi $@"
+    end
+  end
+end
+mainboardinit cpu/x86/16bit/entry16.inc
+ldscript /cpu/x86/16bit/entry16.lds
+
+mainboardinit northbridge/via/vx800/romstrap.inc  
+ldscript /northbridge/via/vx800/romstrap.lds
+
+mainboardinit cpu/x86/32bit/entry32.inc
+ldscript /cpu/x86/32bit/entry32.lds
+if USE_FALLBACK_IMAGE
+	mainboardinit cpu/x86/16bit/reset16.inc
+	ldscript /cpu/x86/16bit/reset16.lds
+else
+	mainboardinit cpu/x86/32bit/reset32.inc
+	ldscript /cpu/x86/32bit/reset32.lds
+end
+
+#mainboardinit arch/i386/lib/cpu_reset.inc    
+#here cpu_reset.inc have label _cpu_reset, which is needed in failover,c, but cpu_reset.inc also has code to jump to __main() which is not included in cache_as_ram_auto_auto.c 
+
+
+mainboardinit arch/i386/lib/id.inc
+ldscript /arch/i386/lib/id.lds
+
+if USE_DCACHE_RAM
+  mainboardinit cpu/via/car/cache_as_ram.inc
+end
+
+if USE_FALLBACK_IMAGE
+	ldscript /arch/i386/lib/failover.lds
+# failover.inc need defination in cpu_reset.inc, but cpu_reset.inc not included,so ...
+# mainboardinit ./failover.inc  
+end
+#mainboardinit cpu/x86/fpu/enable_fpu.inc
+#mainboardinit cpu/x86/mmx/enable_mmx.inc
+
+
+if USE_DCACHE_RAM
+  if CONFIG_USE_INIT
+    initobject cache_as_ram_auto.o
+  else
+    mainboardinit ./cache_as_ram_auto.inc
+  end
+end
+ 
+#mainboardinit cpu/x86/mmx/disable_mmx.inc
+dir /pc80
+
+config chip.h
+
+
+chip northbridge/via/vx800	# Northbridge
+	device pci_domain 0 on
+		device pci 0.0 on end # AGP Bridge
+		device pci 0.1 on end # Error Reporting
+		device pci 0.2 on end # Host Bus Control		
+		device pci 0.3 on end # Memory Controller
+		device pci 0.4 on end # Power Management
+		device pci 0.7 on end # V-Link Controller
+		device pci 1.0 on end # PCI Bridge
+			#device pci f.0 on end # IDE/SATA
+			#device pci f.1 on end # IDE
+			#device pci 10.0 on end # USB 1.1
+			#device pci 10.1 on end # USB 1.1
+			#device pci 10.2 on end # USB 1.1
+			#device pci 10.4 on end # USB 2.0
+			#device pci 11.0 on      # Southbridge LPC
+			#end # pci 11.0		
+			
+	end # pci domain 0
+	device apic_cluster 0 on		# APIC cluster
+		chip cpu/via/model_c7			
+			device apic 0 on end		# APIC
+		end
+	end	
+end 
Index: src/mainboard/via/vx800example/Options.lb
===================================================================
--- src/mainboard/via/vx800example/Options.lb	(Revision 0)
+++ src/mainboard/via/vx800example/Options.lb	(Revision 0)
@@ -0,0 +1,151 @@
+##
+## This file is part of the coreboot project.
+##
+## Copyright (C) 2009 One Laptop per Child, Association, Inc.
+## 
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; version 2 of the License.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+##
+
+uses HAVE_MP_TABLE
+uses CONFIG_CBFS
+uses HAVE_PIRQ_TABLE
+uses USE_FALLBACK_IMAGE
+uses HAVE_FALLBACK_BOOT
+uses HAVE_HARD_RESET
+uses HAVE_OPTION_TABLE
+uses USE_OPTION_TABLE
+uses CONFIG_ROM_PAYLOAD
+uses IRQ_SLOT_COUNT
+uses MAINBOARD
+uses MAINBOARD_VENDOR
+uses MAINBOARD_PART_NUMBER
+uses COREBOOT_EXTRA_VERSION
+uses ARCH
+uses FALLBACK_SIZE
+uses STACK_SIZE
+uses HEAP_SIZE
+uses ROM_SIZE
+uses ROM_SECTION_SIZE
+uses ROM_IMAGE_SIZE
+uses ROM_SECTION_SIZE
+uses ROM_SECTION_OFFSET
+uses CONFIG_ROM_PAYLOAD_START
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_LZMA
+uses PAYLOAD_SIZE
+uses _ROMBASE
+uses _RAMBASE
+uses XIP_ROM_SIZE
+uses XIP_ROM_BASE
+uses HAVE_MP_TABLE
+uses CROSS_COMPILE
+uses CC
+uses HOSTCC
+uses OBJCOPY
+uses DEFAULT_CONSOLE_LOGLEVEL
+uses MAXIMUM_CONSOLE_LOGLEVEL
+uses CONFIG_CONSOLE_SERIAL8250
+uses CONFIG_UDELAY_TSC
+uses CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2
+uses CONFIG_PCI_ROM_RUN
+uses CONFIG_CONSOLE_VGA
+uses CONFIG_MAX_PCI_BUSES
+uses TTYS0_BAUD
+uses CONFIG_VIDEO_MB
+uses CONFIG_IOAPIC
+
+##
+uses USE_DCACHE_RAM
+uses DCACHE_RAM_BASE
+uses DCACHE_RAM_SIZE
+uses CONFIG_USE_INIT
+uses CONFIG_LB_MEM_TOPK
+uses HAVE_ACPI_TABLES
+uses HAVE_MAINBOARD_RESOURCES
+uses HAVE_ACPI_RESUME
+uses HAVE_LOW_TABLES
+
+uses MAINBOARD_PART_NUMBER
+uses MAINBOARD_VENDOR
+uses MAINBOARD_PCI_SUBSYSTEM_VENDOR_ID
+uses MAINBOARD_PCI_SUBSYSTEM_DEVICE_ID
+
+##
+default USE_DCACHE_RAM=1
+default DCACHE_RAM_BASE=0xffef0000
+#default DCACHE_RAM_BASE=0xffbf0000
+#default DCACHE_RAM_BASE=0xfec00000 //hpet may use this 
+default DCACHE_RAM_SIZE=0x2000
+default CONFIG_USE_INIT=0
+# More 1M for pgtbl.
+default HAVE_ACPI_TABLES = 1
+default HAVE_MAINBOARD_RESOURCES = 1
+default HAVE_LOW_TABLES = 0
+default HAVE_ACPI_RESUME = 1
+
+default MAINBOARD_VENDOR = "VIA"
+default MAINBOARD_PART_NUMBER = "vx800ex"
+default MAINBOARD_PCI_SUBSYSTEM_VENDOR_ID = 0x1106
+# default MAINBOARD_PCI_SUBSYSTEM_DEVICE_ID = 0x1234	# FIXME
+
+
+default ROM_SIZE = 512 * 1024
+default CONFIG_IOAPIC = 1
+
+#define framebuffer size integrated graphics card. support 32 64 128 256
+default CONFIG_VIDEO_MB = 64
+
+default CONFIG_CONSOLE_SERIAL8250 = 1
+default CONFIG_PCI_ROM_RUN = 0
+default CONFIG_CONSOLE_VGA = 0
+default HAVE_FALLBACK_BOOT = 1
+default HAVE_MP_TABLE = 0
+default CONFIG_UDELAY_TSC = 1
+default CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2 = 1
+default HAVE_HARD_RESET = 0
+default HAVE_PIRQ_TABLE = 0
+default IRQ_SLOT_COUNT = 10
+default HAVE_OPTION_TABLE = 1
+default ROM_IMAGE_SIZE = 128 * 1024
+default FALLBACK_SIZE = ROM_IMAGE_SIZE
+default USE_FALLBACK_IMAGE = 1
+default STACK_SIZE = 16 * 1024
+default HEAP_SIZE = 20 * 1024
+#default USE_OPTION_TABLE = !USE_FALLBACK_IMAGE
+default USE_OPTION_TABLE = 0
+# More 1M for pgtbl.
+default CONFIG_LB_MEM_TOPK = 32768
+# to 1MB
+default _RAMBASE = 0x1F00000
+default CONFIG_ROM_PAYLOAD = 1
+default CROSS_COMPILE = ""
+default CC = "$(CROSS_COMPILE)gcc -m32"
+default HOSTCC = "gcc"
+
+##
+## Set this to the max PCI bus number you would ever use for PCI config I/O.
+## Setting this number very high will make pci_locate_device() take a long
+## time when it can't find a device.
+##
+default CONFIG_MAX_PCI_BUSES = 3
+
+#
+# CBFS
+#
+#
+default CONFIG_CBFS=1
+end
+
+end
+
Index: src/mainboard/via/vx800example/acpi_tables.c
===================================================================
--- src/mainboard/via/vx800example/acpi_tables.c	(Revision 0)
+++ src/mainboard/via/vx800example/acpi_tables.c	(Revision 0)
@@ -0,0 +1,193 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2009 One Laptop per Child, Association, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+
+#include <console/console.h>
+#include <string.h>
+#include <arch/acpi.h>
+#include <arch/smp/mpspec.h>
+#include <device/device.h>
+#include <device/pci_ids.h>
+#include <../../../northbridge/via/vx800/vx800.h>
+
+extern unsigned char AmlCode_dsdt[];
+extern unsigned char AmlCode_ssdt[];
+
+unsigned long acpi_fill_mcfg(unsigned long current)
+{
+   	/*no pci-e in chipset,  but there is a mmconfig_BAR in d0f5, so... */
+	device_t dev;
+	struct resource *res;
+	dev = dev_find_device(PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_VX800_NB_CTC, 0);
+	if (!dev)
+		return current;
+
+	res = find_resource(dev, VX800_D0F5_MMCONFIG_MBAR);
+	if (res) {
+		current += acpi_create_mcfg_mmconfig((acpi_mcfg_mmconfig_t *)
+				current, res->base, 0x0, 0x0, 0x04);
+	}
+	return current;
+}
+
+
+unsigned long acpi_create_madt_lapic_nmis(unsigned long current, u16 flags, u8 lint)
+{
+	device_t cpu;
+	int cpu_index = 0;
+
+	for(cpu = all_devices; cpu; cpu = cpu->next) {
+		if ((cpu->path.type != DEVICE_PATH_APIC) ||
+		   (cpu->bus->dev->path.type != DEVICE_PATH_APIC_CLUSTER)) {
+			continue;
+		}
+		if (!cpu->enabled) {
+			continue;
+		}
+		current += acpi_create_madt_lapic_nmi((acpi_madt_lapic_nmi_t *)current, cpu_index, flags, lint);
+		cpu_index++;
+	}
+	return current;
+}
+
+unsigned long acpi_fill_madt(unsigned long current)
+{
+	unsigned int gsi_base = 0x18;
+
+	/* Create all subtables for processors. */
+	current = acpi_create_madt_lapics(current);
+
+	/* Write SB IOAPIC. */
+	current += acpi_create_madt_ioapic((acpi_madt_ioapic_t *) current,
+				VX800_APIC_SB_ID, VX800_APIC_SB_BASE, 0);
+
+	/* IRQ0 -> APIC IRQ2. */
+	current += acpi_create_madt_irqoverride((acpi_madt_irqoverride_t *)
+						current, 0, 0, 2, 0x0);	
+
+	/* IRQ9 ACPI active low. */
+	current += acpi_create_madt_irqoverride((acpi_madt_irqoverride_t *)
+		current, 0, 9, 9, MP_IRQ_TRIGGER_LEVEL | MP_IRQ_POLARITY_LOW);
+
+	/* Create all subtables for processors. */
+	current = acpi_create_madt_lapic_nmis(current,
+			MP_IRQ_TRIGGER_EDGE | MP_IRQ_POLARITY_HIGH, 1);
+
+	return current;
+}
+
+unsigned long acpi_fill_srat(unsigned long current)
+{
+	/* No NUMA, no SRAT */
+}
+
+unsigned long acpi_fill_slit(unsigned long current)
+{
+}
+
+#define ALIGN(x,a)              __ALIGN_MASK(x,(typeof(x))(a)-1)
+#define __ALIGN_MASK(x,mask)    (((x)+(mask))&~(mask))
+
+unsigned long write_acpi_tables(unsigned long start)
+{
+	unsigned long current;
+	acpi_rsdp_t *rsdp;
+	acpi_srat_t *srat;
+	acpi_rsdt_t *rsdt;
+	acpi_mcfg_t *mcfg;
+	acpi_hpet_t *hpet;
+	acpi_madt_t *madt;
+	acpi_fadt_t *fadt;
+	acpi_facs_t *facs;
+	acpi_header_t *dsdt;
+	acpi_header_t *ssdt;
+	
+	/* Align ACPI tables to 16byte */
+	start   = ( start + 0x0f ) & -0x10;
+	current = start;
+	
+	printk_info("ACPI: Writing ACPI tables at %lx...\n", start);
+
+	/* We need at least an RSDP and an RSDT Table */
+	rsdp = (acpi_rsdp_t *) current;
+	current += sizeof(acpi_rsdp_t);
+	rsdt = (acpi_rsdt_t *) current;
+	current += sizeof(acpi_rsdt_t);
+
+	/* clear all table memory */
+	memset((void *)start, 0, current - start);
+	
+	acpi_write_rsdp(rsdp, rsdt);
+	acpi_write_rsdt(rsdt);
+	
+	/*
+	 * We explicitly add these tables later on:
+	 */
+	printk_debug("ACPI:     * FACS\n");
+	current = ALIGN(current, 64);
+	facs = (acpi_facs_t *) current;
+	current += sizeof(acpi_facs_t);
+	acpi_create_facs(facs);
+
+	printk_debug("ACPI:     * DSDT\n");
+	dsdt = (acpi_header_t *) current;
+	current += ((acpi_header_t *)AmlCode_dsdt)->length;
+	memcpy((void *)dsdt,(void *)AmlCode_dsdt, ((acpi_header_t *)AmlCode_dsdt)->length);
+	dsdt->checksum = 0; /* don't trust intel iasl compiler to get this right. */
+	dsdt->checksum = acpi_checksum(dsdt, dsdt->length);
+	printk_debug("ACPI:     * DSDT @ %08x Length %x\n", dsdt, dsdt->length);
+	
+	printk_debug("ACPI:     * FADT\n");
+	fadt = (acpi_fadt_t *) current;
+	current += sizeof(acpi_fadt_t);
+
+	acpi_create_fadt(fadt,facs,dsdt);
+	acpi_add_table(rsdt,fadt);
+
+	/* If we want to use HPET timers Linux wants it in MADT. */
+	printk_debug("ACPI:    * MADT\n");
+	madt = (acpi_madt_t *) current;
+	acpi_create_madt(madt);
+	current += madt->header.length;
+	acpi_add_table(rsdt, madt);
+	
+	printk_debug("ACPI:    * MCFG\n");
+	mcfg = (acpi_mcfg_t *) current;
+	acpi_create_mcfg(mcfg);
+	current += mcfg->header.length;
+	acpi_add_table(rsdt, mcfg);
+
+
+	printk_debug("ACPI:    * HPET\n");
+	hpet = (acpi_mcfg_t *) current;
+	acpi_create_hpet(hpet);
+	current += hpet->header.length;
+	acpi_add_table(rsdt, hpet);
+	
+	/*printk_debug("ACPI:     * SSDT\n");
+	ssdt = (acpi_header_t *) current;
+	current += ((acpi_header_t *)AmlCode_ssdt)->length;
+	memcpy((void *)ssdt,(void *)AmlCode_ssdt, ((acpi_header_t *)AmlCode_ssdt)->length);
+	ssdt->checksum = 0; // don't trust intel iasl compiler to get this right
+	ssdt->checksum = acpi_checksum(ssdt, ssdt->length);
+	acpi_add_table(rsdt, ssdt);
+	printk_debug("ACPI:     * SSDT @ %08x Length %x\n", ssdt, ssdt->length);
+	*/	
+	printk_info("ACPI: done.\n");
+	return current;
+}
